#/bin/sh

CMDS="jq wget unzip node npm"
for cmd in $CMDS; do
	if [ -z $(command -v $cmd) ]; then
		echo -e "\e[31m$cmd tool is required\e[m"
		echo -e "check for $CMDS tools\n"
		exit
	fi
done

if [ -z $(command -v r.js) ]; then
	echo -e "\e[31mNode module requirejs is required\e[m"
	echo -e "Please run : \e[36msudo -H npm install -g requirejs\e[m"
	exit
fi

# Where to download the last version of codemirror
URL="https://codemirror.net/codemirror.zip"

TMP_FILE=$(mktemp --suffix .zip)

rm -f codemirror.zip
wget -O ${TMP_FILE} ${URL}
unzip ${TMP_FILE}
rm ${TMP_FILE}
rm main.js

WORKING_DIR=$(find . -type d -name 'codemirror*' | sort | tail -n 1)
cd "${WORKING_DIR}"
npm install
version=$(jq -ra '.version' package.json)
cd ..

# update build.js with new version
# r.js -o build.js
r.js -o out=main.js name=../app baseUrl=${WORKING_DIR}

echo -e "\e[33mCodemirror - version ${version}\e[0m"
echo -e "\nDone\n"
